//
//  ViewController.swift
//  TestFlexLayout
//
//  Created by Anatoliy on 28.02.2018.
//  Copyright © 2018 Anatoliy. All rights reserved.
//

import UIKit
import FlexLayout


class ViewController: UIViewController {
    
    
    lazy var buttonAnimate: UIButton = {
        let button = UIButton(type: .system)
        button.setTitle("Start Animate", for: .normal)
        button.addTarget(self, action: #selector(handlerButtonAnimate), for: .touchUpInside)
        //        button.translatesAutoresizingMaskIntoConstraints = false
        return button
    }()
    
    
    let stack: UIStackView = {
        let stack = UIStackView()
        stack.axis = .horizontal
        stack.alignment = .fill
        stack.distribution = .fillProportionally
        //        stack.translatesAutoresizingMaskIntoConstraints = false
        return stack
    }()
    
    
    let label_1: UILabel = {
        let label = UILabel()
        label.text = "TEST LABEL_1 tex"
        label.backgroundColor = .red
        label.numberOfLines = 0
        //        label.translatesAutoresizingMaskIntoConstraints = false
        return label
    }()
    
    let label_2: UILabel = {
        let label = UILabel()
        label.text = "TEST LABEL_2 tex"
        label.backgroundColor = .blue
        label.numberOfLines = 0
        //        label.translatesAutoresizingMaskIntoConstraints = false
        return label
    }()
    
    let titleLabel: UILabel = {
        let label = UILabel()
        label.textColor = .black
        label.numberOfLines = 0
        label.text = "Headline small test test"
        label.font = UIFont.systemFont(ofSize: 18)
        return label
    }()
    
    let infoLabel: UILabel = {
        let label = UILabel()
        label.textColor = .lightGray
        label.text = "If I'm not mistaken, then flex incorrectly calculates the dimensions If I'm not mistaken, then flex incorrectly calculates the dimensions If I'm not mistaken, then flex incorrectly calculates the dimensions"
        label.numberOfLines = 0
        label.font = UIFont.systemFont(ofSize: 16)
        return label
    }()
    
    let rootFlexContainer = UIView()
    
    
    override func viewDidLayoutSubviews() {
        super.viewDidLayoutSubviews()
        
        rootFlexContainer.flex.layout(mode: .adjustHeight)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        rootFlexContainer.flex.paddingHorizontal(16).define { (flex) in
            flex.addItem(titleLabel).alignSelf(.center)
            flex.addItem(infoLabel).marginTop(16)
            flex.addItem(label_2).alignSelf(.center).marginTop(16)
            flex.addItem(buttonAnimate).marginTop(16).alignSelf(.center)
        }
        
        self.view.addSubview(rootFlexContainer)
        
        rootFlexContainer.translatesAutoresizingMaskIntoConstraints = false
        
        NSLayoutConstraint.activate([
            rootFlexContainer.leadingAnchor.constraint(equalTo: view.leadingAnchor, constant: 16),
            rootFlexContainer.trailingAnchor.constraint(equalTo: view.trailingAnchor, constant: -16),
            rootFlexContainer.centerYAnchor.constraint(equalTo: view.centerYAnchor)
            ])
        
        
        
    }
    
    
    
    @objc func handlerButtonAnimate(sender: UIButton) {
        
        
        UIView.animate(withDuration: 0.5, delay: 0, usingSpringWithDamping: 1, initialSpringVelocity: 1, options: .curveEaseOut, animations: {
            //            self.label_1.flex.alignSelf(.start)
            self.label_2.flex.width(0)
            self.rootFlexContainer.flex.layout()
        }) { (completed) in
            UIView.animate(withDuration: 0.5, delay: 0, usingSpringWithDamping: 1, initialSpringVelocity: 1, options: .curveEaseOut, animations: {
                
                // reset to the default item's width
                self.label_2.flex.width(nil)
                self.rootFlexContainer.flex.layout()
            }, completion: nil)
        }
        
    }
    
    
}

